<?
//    program: RENTABILITA VYROBY
//      autor: MAREK LACO, 2001
//
//kroky programu
//   0  - menu
//   1  - zadavanie vstupov
//   2  - zadiane rentability a vypocet
//    22  - po zadanej rentabilite vlastny pypocet
//   3  - koniec
//    33 - naozaj koniec

if(!isSet($krok))
  $krok = 0;

function ahref($krok)
//vygeneruje tag z danym krokom a ostatne premenne ostavaju
{
  global $QUERY_STRING;
  global $SCRIPT_NAME;

  if(empty($QUERY_STRING))
    $query = "?krok=$krok";
   elseif(!strstr($QUERY_STRING,"krok"))  
    $query = "?krok=$krok&$QUERY_STRING";
   else
    $query = "?".ereg_replace("krok=[^&]*", "krok=$krok", $QUERY_STRING);

  echo "<a href='$SCRIPT_NAME$query'>";  
}

 if($p != (string)(int)($p))
  $p = 0;

 $c = (double)$c;
 $a = (double)$a;
 $b = (double)$b;
 $p = (double)$p;

 function ukaz($var)
 //vypise nazov premennej a jej hodnotu
 {
   global $$var;
   echo "<B>$var</B>: {$$var}<br>\n";
 }

 function zaokruhli($cislo)
 //zaokruhli na tu definovany pocet des. miest
 // Round() - druhy parameter pozna len PHP4!
 {
   return(Round($cislo,3));
 }

 function td_zobraz($var,$takakoje = 0)
 //na vypisovanie do tabulky
 {
   if ($takakoje)
     echo "<td align=center>".$var;
    else 
     echo "<td align=right nowrap>".number_format($var,3,"."," ");
 }

?>
<html>
<head>
 <META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=windows-1250">
 <title>MTAIS - Rentabilita vroby</title>
</head>

<style>
body {
 background-color: white;
}
</style>

<body>

<!-- 9.1 identifikacia aplikacneho programu -->
<h1>Rentabilita vroby</h1>

<? if($krok == 0): ?>
<small>
nzov programu: RENTABILITA VROBY<br>
autor: MAREK LACO<br>
programovac jazyk: PHP4<br>
dtum: 26.4.2001<br>
</small>

<hr>
<!-- 9.2 modul hlavneho menu -->
1. <? ahref(1); ?>Vstup dajov</a><br>
2. <? ahref(2); ?>Vpoet tabuky</a><br>
3. <? ahref(3); ?>Koniec programu</a><br>

<? endif; //0 ?>

<!-- 9.3 cast programu zadavania vstupnych udajov -->
<? if($krok == 1): ?>
<script language="JavaScript">
<!--
function kontrolny_sucet(form)
{
 if(parseInt(form.K.value) == (parseInt(form.a.value) + parseInt(form.b.value) + parseInt(form.c.value)))
   return true;
  else
   {
     alert("Kontroln set neshlas!\nSkontroluj daje");
     return false;
   }
}
-->
</script>

<form method="get" onsubmit="return kontrolny_sucet(this)">

cena [<B>c</B>] <input type=text size=3 name=c value="<? echo $c?>"> <br>

var. nklady [<B>a</B>] <input type=text size=3 name=a value="<? echo $a?>"> <br>

fix. nklady [<B>b</B>] <input type=text size=5 name=b value="<? echo $b?>"> <br>

kontroln set [<B>K</B>] <input type=text size=5 name=K value="<? echo $K?>"><br>

<br>
<input type=submit value="OK">
</form>
<? endif; //1 ?>


<? if($krok == 2): ?>
<hr>
<?
if(empty($c)||empty($a)||empty($b))
  {
   echo "Nemono spravi vpoet, lebo neboli zadan vstupn daje!<br><br>";
   ahref(0);
   echo "Nvrat do menu</a><br><br>";
  }
 else
  { ?>
<form method="get">
<input type=hidden name=krok value=22>
<input type=hidden name=c value="<? echo $c; ?>">
<input type=hidden name=a value="<? echo $a; ?>">
<input type=hidden name=b value="<? echo $b; ?>">
<input type=hidden name=K value="<? echo $K; ?>">

zadaj rentabilitu vroby [<B>p</B>]

<input type=text size=3 name=p value="<? echo $p?>"> % <br>
<br>
<input type=submit value="OK">
</form>
<? } // boli vstupne udaje ?>
<? endif; //2 ?>

<? if($krok == 22): ?>
<hr>

<?
if(empty($c)||empty($a)||empty($b)||(!isSet($p)))
  {
   echo "Nemono spravi vpoet, lebo neboli zadavn vstupn daje!<br><br>";
   ahref(0);
   echo "Nvrat do menu</a><br><br>";
  }
 else
  {
?>

cena [<B>c</B>] <? echo $c; ?>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
var. nklady [<B>a</B>] <? echo $a; ?>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
fix. nklady [<B>b</B>] <? echo $b; ?>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
rentabilita [<B>p</B>] <? echo $p; ?> %
<br>
<hr>

<?

//9.4 cast programu pre vypocet vychodiskoveho mnozstva vyrobkov 
//pre tabulkove vypocty

//z - priemerny zisk na vyrobok
$z = zaokruhli(($c/100) * $p);

//X - celkova produkcia pre danu rentabilitu
//zo vzorca cX = aX + b + zX; ==> X = -b/(a-c+z)
$X = zaokruhli(- $b / ($a - $c + $z));

$w = $X / 10;

//9.5 cast programu pre vypocet riadkov a stlpcov tabulky
for($r=1;$r<=10;$r++)
 {
   $x[$r] = zaokruhli($w * $r);
   $T[$r] = zaokruhli($x[$r] * $c);
   $V[$r] = zaokruhli($x[$r] * $a);
   $G[$r] = zaokruhli($V[$r] + $b);
   $H[$r] = zaokruhli($T[$r] - $G[$r]);
   $P[$r] = zaokruhli(($H[$r] * 100) / $T[$r]);
   $F[$r] = zaokruhli($b / $x[$r]);
   $N[$r] = zaokruhli($F[$r] + $a);
   $U[$r] = zaokruhli($c - $N[$r]);
   $s[$r] = zaokruhli(($U[$r] * 100) / $c);
 }


ukaz("z");
ukaz("X");
ukaz("w");


?>

<br>

<!-- vypis zahlavia tabulky -->
<table border=1>
 <tr>
  <th>r<br>
<small></small><br>
  <th>x<br>
<small>mnos. vroby</small><br>1<br>  <small>(r*w)</small><br>
  <th>T<br>
<small>trby</small><br>2<br> <small>(x*c)</small><br>
  <th>V<br>
<small>var. nkl.</small><br>3<br> <small>(x*a)</small><br>
  <th>G<br>
<small>nkl. vroby</small><br>4<br> <small>(V+b)</small><br>
  <th>H<br>
<small>HV</small><br>5<br> <small>(T-V)</small><br>
  <th>P<br>
<small>% HV</small><br>6<br> <small>(H*100/T)</small><br>
  <th>F<br>
<small>fix. nkl. / kus</small><br>7<br> <small>(b/x)</small><br>
  <th>N<br>
<small>celk. nkl. / kus</small><br>8<br> <small>(F+a)</small><br>
  <th>U<br>
<small>HV / kus</small><br>9<br> <small>(c-N)</small><br>
  <th>s<br>
<small>% HV / kus</small><br>10<br> <small>(U*100/c)</small><br>


<?

//zobrazenie jednotliych riadkov tabulky
for($r=1;$r<=10;$r++)
 {
echo "<tr>";
td_zobraz($r,1);
td_zobraz($x[$r]);
td_zobraz($T[$r]);
td_zobraz($V[$r]);
td_zobraz($G[$r]);
td_zobraz($H[$r]);
td_zobraz($P[$r]);
td_zobraz($F[$r]);
td_zobraz($N[$r]);
td_zobraz($U[$r]);
td_zobraz($s[$r]);
 }
?>
</table>

<br>

<? ahref(0); ?>Nvrat do menu</a><br>
<br>


<? } //zadane udaje ?>
<? endif; //22 ?>

<!-- 9.6 cast programu pre pokracovanie, alebo ukoncenie prace programu -->
<? if($krok == 3): ?>
<hr>
Skutone ukonit innos programu?<br>
<br>
1. <? ahref(0); ?>Nasp do Menu</a><br>
2. <a href="<? echo $SCRIPT_NAME; ?>?krok=33">Skutone ukoni program</a><br>
<? endif; //3 ?>

<? if($krok == 33): ?>
<hr>
Koniec<br>
<? endif; //33 ?>

<hr>

</body>
</html>
